package com.sztzjy.money_management.config.security;

import com.sztzjy.money_management.entity.UserInfo;
import com.sztzjy.money_management.entity.UserInfoExample;
import com.sztzjy.money_management.mapper.UserInfoMapper;
import io.jsonwebtoken.lang.Assert;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;


@Service
public class AuthenticationService implements UserDetailsService {
    @Resource
    private UserInfoMapper stuUserMapper;



    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        UserInfoExample stuUserExample = new UserInfoExample();
        stuUserExample.createCriteria().andUsernameEqualTo(username);
        List<UserInfo> list = stuUserMapper.selectByExample(stuUserExample);
        Assert.notNull(list, "用户不存在");
        UserInfo user = list.get(0);
        JwtUser jwtUser = new JwtUser();
        jwtUser.setUsername(user.getUsername());
        jwtUser.setPassword(new BCryptPasswordEncoder().encode(user.getPassword()));  //不加密会报错Encoded password does not look like BCrypt
        jwtUser.setUserId(user.getUserid());
        jwtUser.setName(user.getName());
        jwtUser.setRoleId(user.getRoleId());
        jwtUser.setStudentId(user.getStudentId());
        return jwtUser;
    }

}
