package com.sztzjy.money_management.mapper;

import com.sztzjy.money_management.entity.SynthesisPlanScore;
import com.sztzjy.money_management.entity.SynthesisPlanScoreExample;
import com.sztzjy.money_management.entity.SynthesisPlanScoreKey;
import com.sztzjy.money_management.entity.SynthesisPlanScoreWithBLOBs;

import java.math.BigDecimal;
import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface SynthesisPlanScoreMapper {
    long countByExample(SynthesisPlanScoreExample example);

    int deleteByExample(SynthesisPlanScoreExample example);

    int deleteByPrimaryKey(SynthesisPlanScoreKey key);

    int insert(SynthesisPlanScoreWithBLOBs record);

    int insertSelective(SynthesisPlanScoreWithBLOBs record);

    List<SynthesisPlanScoreWithBLOBs> selectByExampleWithBLOBs(SynthesisPlanScoreExample example);

    List<SynthesisPlanScore> selectByExample(SynthesisPlanScoreExample example);

    SynthesisPlanScoreWithBLOBs selectByPrimaryKey(SynthesisPlanScoreKey key);

    int updateByExampleSelective(@Param("record") SynthesisPlanScoreWithBLOBs record, @Param("example") SynthesisPlanScoreExample example);

    int updateByExampleWithBLOBs(@Param("record") SynthesisPlanScoreWithBLOBs record, @Param("example") SynthesisPlanScoreExample example);

    int updateByExample(@Param("record") SynthesisPlanScore record, @Param("example") SynthesisPlanScoreExample example);

    int updateByPrimaryKeySelective(SynthesisPlanScoreWithBLOBs record);

    int updateByPrimaryKeyWithBLOBs(SynthesisPlanScoreWithBLOBs record);

    int updateByPrimaryKey(SynthesisPlanScore record);

    @Select("SELECT SUM(score) FROM synthesis_plan_score WHERE userid=#{userId} AND caseid=#{caseId}")
    Double getTotalScore(@Param("userId") String userId,@Param("caseId") String caseId);

    @Select("SELECT SUM(score) FROM synthesis_plan_score WHERE userid=#{userId} AND caseid=#{caseId}")
    BigDecimal selectTotalScoreByUserIdAndCaseId(@Param("userId")String userId,@Param("caseId") String caseid);

    @Select("SELECT SUM(score) FROM synthesis_plan_score WHERE userid=#{userId}")
    BigDecimal selectTotalScoreByUserId(@Param("userId")String userId);

    int batchInsert(@Param("list") List<SynthesisPlanScoreWithBLOBs> synthesisPlanScore);
}